/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel.impl;

import com.example.rule.ecore.rulemetamodel.RCondElem;
import com.example.rule.ecore.rulemetamodel.RCondElemEnum;
import com.example.rule.ecore.rulemetamodel.RDataType;
import com.example.rule.ecore.rulemetamodel.RFact;
import com.example.rule.ecore.rulemetamodel.RFactAddress;
import com.example.rule.ecore.rulemetamodel.RFactSlot;
import com.example.rule.ecore.rulemetamodel.RFactTemplate;
import com.example.rule.ecore.rulemetamodel.RFloat;
import com.example.rule.ecore.rulemetamodel.RFunction;
import com.example.rule.ecore.rulemetamodel.RFunctionType;
import com.example.rule.ecore.rulemetamodel.RInteger;
import com.example.rule.ecore.rulemetamodel.RList;
import com.example.rule.ecore.rulemetamodel.RModule;
import com.example.rule.ecore.rulemetamodel.RMultiField;
import com.example.rule.ecore.rulemetamodel.RObject;
import com.example.rule.ecore.rulemetamodel.RPattern;
import com.example.rule.ecore.rulemetamodel.RRule;
import com.example.rule.ecore.rulemetamodel.RRuleType;
import com.example.rule.ecore.rulemetamodel.RSlotMatchExp;
import com.example.rule.ecore.rulemetamodel.RSymbol;
import com.example.rule.ecore.rulemetamodel.RulemetamodelFactory;
import com.example.rule.ecore.rulemetamodel.RulemetamodelPackage;

import java.util.Map;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class RulemetamodelPackageImpl extends EPackageImpl implements RulemetamodelPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rListEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rFactTemplateEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rFactSlotEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rPatternEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rSlotMatchExpEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rCondElemEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rModuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rObjectEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rFunctionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rFactEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rSymbolToDataTypeMapEntryEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum rCondElemEnumEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum rRuleTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum rFunctionTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType rSymbolEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType rFactAddressEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType rIntegerEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType rFloatEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType rDataTypeEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType rMultiFieldEDataType = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private RulemetamodelPackageImpl() {
		super(eNS_URI, RulemetamodelFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static RulemetamodelPackage init() {
		if (isInited) return (RulemetamodelPackage)EPackage.Registry.INSTANCE.getEPackage(RulemetamodelPackage.eNS_URI);

		// Obtain or create and register package
		RulemetamodelPackageImpl theRulemetamodelPackage = (RulemetamodelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof RulemetamodelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new RulemetamodelPackageImpl());

		isInited = true;

		// Create package meta-data objects
		theRulemetamodelPackage.createPackageContents();

		// Initialize created meta-data
		theRulemetamodelPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theRulemetamodelPackage.freeze();

		return theRulemetamodelPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRList() {
		return rListEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRList_ListElements() {
		return (EAttribute)rListEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRFactTemplate() {
		return rFactTemplateEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRFactTemplate_Slot() {
		return (EReference)rFactTemplateEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRFactTemplate_FactName() {
		return (EAttribute)rFactTemplateEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRRule() {
		return rRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRRule_Salience() {
		return (EAttribute)rRuleEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRRule_Condition() {
		return (EReference)rRuleEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRRule_RuleName() {
		return (EAttribute)rRuleEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRRule_Actions() {
		return (EReference)rRuleEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRRule_RuleType() {
		return (EAttribute)rRuleEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRRule_CeMatchPattern() {
		return (EReference)rRuleEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRRule_Description() {
		return (EAttribute)rRuleEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRFactSlot() {
		return rFactSlotEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRFactSlot_SlotName() {
		return (EAttribute)rFactSlotEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRFactSlot_SlotValueRange() {
		return (EAttribute)rFactSlotEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRPattern() {
		return rPatternEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRPattern_FactTemplate() {
		return (EReference)rPatternEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRPattern_SlotMatchExp() {
		return (EReference)rPatternEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRSlotMatchExp() {
		return rSlotMatchExpEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRSlotMatchExp_FactTemplate() {
		return (EReference)rSlotMatchExpEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRSlotMatchExp_SlotName() {
		return (EAttribute)rSlotMatchExpEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRSlotMatchExp_MatchExp() {
		return (EAttribute)rSlotMatchExpEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRCondElem() {
		return rCondElemEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRCondElem_CeName() {
		return (EAttribute)rCondElemEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRCondElem_CeMatchPattern() {
		return (EReference)rCondElemEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRCondElem_ChildCE() {
		return (EReference)rCondElemEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRModule() {
		return rModuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRModule_FactTemplates() {
		return (EReference)rModuleEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRModule_Rules() {
		return (EReference)rModuleEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRModule_Rlists() {
		return (EReference)rModuleEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRModule_Functions() {
		return (EReference)rModuleEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRModule_OutputFilePath() {
		return (EAttribute)rModuleEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRObject() {
		return rObjectEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRFunction() {
		return rFunctionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRFunction_FunctionName() {
		return (EAttribute)rFunctionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRFunction_Parameters() {
		return (EAttribute)rFunctionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRFunction_ReturnValue() {
		return (EAttribute)rFunctionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRFunction_FunctionType() {
		return (EAttribute)rFunctionEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRFact() {
		return rFactEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRFact_FactTemplate() {
		return (EReference)rFactEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRFact_Slots() {
		return (EReference)rFactEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRSymbolToDataTypeMapEntry() {
		return rSymbolToDataTypeMapEntryEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRSymbolToDataTypeMapEntry_Key() {
		return (EAttribute)rSymbolToDataTypeMapEntryEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRSymbolToDataTypeMapEntry_Value() {
		return (EAttribute)rSymbolToDataTypeMapEntryEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getRCondElemEnum() {
		return rCondElemEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getRRuleType() {
		return rRuleTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getRFunctionType() {
		return rFunctionTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getRSymbol() {
		return rSymbolEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getRFactAddress() {
		return rFactAddressEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getRInteger() {
		return rIntegerEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getRFloat() {
		return rFloatEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getRDataType() {
		return rDataTypeEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getRMultiField() {
		return rMultiFieldEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RulemetamodelFactory getRulemetamodelFactory() {
		return (RulemetamodelFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		rListEClass = createEClass(RLIST);
		createEAttribute(rListEClass, RLIST__LIST_ELEMENTS);

		rFactTemplateEClass = createEClass(RFACT_TEMPLATE);
		createEReference(rFactTemplateEClass, RFACT_TEMPLATE__SLOT);
		createEAttribute(rFactTemplateEClass, RFACT_TEMPLATE__FACT_NAME);

		rRuleEClass = createEClass(RRULE);
		createEAttribute(rRuleEClass, RRULE__SALIENCE);
		createEReference(rRuleEClass, RRULE__CONDITION);
		createEAttribute(rRuleEClass, RRULE__RULE_NAME);
		createEReference(rRuleEClass, RRULE__ACTIONS);
		createEAttribute(rRuleEClass, RRULE__RULE_TYPE);
		createEReference(rRuleEClass, RRULE__CE_MATCH_PATTERN);
		createEAttribute(rRuleEClass, RRULE__DESCRIPTION);

		rFactSlotEClass = createEClass(RFACT_SLOT);
		createEAttribute(rFactSlotEClass, RFACT_SLOT__SLOT_NAME);
		createEAttribute(rFactSlotEClass, RFACT_SLOT__SLOT_VALUE_RANGE);

		rPatternEClass = createEClass(RPATTERN);
		createEReference(rPatternEClass, RPATTERN__FACT_TEMPLATE);
		createEReference(rPatternEClass, RPATTERN__SLOT_MATCH_EXP);

		rSlotMatchExpEClass = createEClass(RSLOT_MATCH_EXP);
		createEReference(rSlotMatchExpEClass, RSLOT_MATCH_EXP__FACT_TEMPLATE);
		createEAttribute(rSlotMatchExpEClass, RSLOT_MATCH_EXP__SLOT_NAME);
		createEAttribute(rSlotMatchExpEClass, RSLOT_MATCH_EXP__MATCH_EXP);

		rCondElemEClass = createEClass(RCOND_ELEM);
		createEAttribute(rCondElemEClass, RCOND_ELEM__CE_NAME);
		createEReference(rCondElemEClass, RCOND_ELEM__CE_MATCH_PATTERN);
		createEReference(rCondElemEClass, RCOND_ELEM__CHILD_CE);

		rModuleEClass = createEClass(RMODULE);
		createEReference(rModuleEClass, RMODULE__FACT_TEMPLATES);
		createEReference(rModuleEClass, RMODULE__RULES);
		createEReference(rModuleEClass, RMODULE__RLISTS);
		createEReference(rModuleEClass, RMODULE__FUNCTIONS);
		createEAttribute(rModuleEClass, RMODULE__OUTPUT_FILE_PATH);

		rObjectEClass = createEClass(ROBJECT);

		rFunctionEClass = createEClass(RFUNCTION);
		createEAttribute(rFunctionEClass, RFUNCTION__FUNCTION_NAME);
		createEAttribute(rFunctionEClass, RFUNCTION__PARAMETERS);
		createEAttribute(rFunctionEClass, RFUNCTION__RETURN_VALUE);
		createEAttribute(rFunctionEClass, RFUNCTION__FUNCTION_TYPE);

		rFactEClass = createEClass(RFACT);
		createEReference(rFactEClass, RFACT__FACT_TEMPLATE);
		createEReference(rFactEClass, RFACT__SLOTS);

		rSymbolToDataTypeMapEntryEClass = createEClass(RSYMBOL_TO_DATA_TYPE_MAP_ENTRY);
		createEAttribute(rSymbolToDataTypeMapEntryEClass, RSYMBOL_TO_DATA_TYPE_MAP_ENTRY__KEY);
		createEAttribute(rSymbolToDataTypeMapEntryEClass, RSYMBOL_TO_DATA_TYPE_MAP_ENTRY__VALUE);

		// Create enums
		rCondElemEnumEEnum = createEEnum(RCOND_ELEM_ENUM);
		rRuleTypeEEnum = createEEnum(RRULE_TYPE);
		rFunctionTypeEEnum = createEEnum(RFUNCTION_TYPE);

		// Create data types
		rSymbolEDataType = createEDataType(RSYMBOL);
		rFactAddressEDataType = createEDataType(RFACT_ADDRESS);
		rIntegerEDataType = createEDataType(RINTEGER);
		rFloatEDataType = createEDataType(RFLOAT);
		rDataTypeEDataType = createEDataType(RDATA_TYPE);
		rMultiFieldEDataType = createEDataType(RMULTI_FIELD);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Add supertypes to classes
		rListEClass.getESuperTypes().add(this.getRObject());
		rFactTemplateEClass.getESuperTypes().add(this.getRObject());
		rRuleEClass.getESuperTypes().add(this.getRObject());
		rFactSlotEClass.getESuperTypes().add(this.getRObject());
		rPatternEClass.getESuperTypes().add(this.getRObject());
		rSlotMatchExpEClass.getESuperTypes().add(this.getRObject());
		rCondElemEClass.getESuperTypes().add(this.getRObject());
		rModuleEClass.getESuperTypes().add(this.getRObject());
		rFunctionEClass.getESuperTypes().add(this.getRObject());
		rFactEClass.getESuperTypes().add(this.getRObject());

		// Initialize classes and features; add operations and parameters
		initEClass(rListEClass, RList.class, "RList", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRList_ListElements(), this.getRDataType(), "listElements", null, 0, -1, RList.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rFactTemplateEClass, RFactTemplate.class, "RFactTemplate", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRFactTemplate_Slot(), this.getRFactSlot(), null, "Slot", null, 0, -1, RFactTemplate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRFactTemplate_FactName(), this.getRSymbol(), "factName", null, 0, 1, RFactTemplate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rRuleEClass, RRule.class, "RRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRRule_Salience(), ecorePackage.getEInt(), "Salience", null, 0, 1, RRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRRule_Condition(), this.getRCondElem(), null, "condition", null, 0, 1, RRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRRule_RuleName(), this.getRSymbol(), "ruleName", null, 0, 1, RRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRRule_Actions(), this.getRFunction(), null, "actions", null, 0, -1, RRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRRule_RuleType(), this.getRRuleType(), "ruleType", null, 0, 1, RRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRRule_CeMatchPattern(), this.getRPattern(), null, "ceMatchPattern", null, 0, -1, RRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRRule_Description(), ecorePackage.getEString(), "description", null, 0, 1, RRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rFactSlotEClass, RFactSlot.class, "RFactSlot", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRFactSlot_SlotName(), this.getRSymbol(), "slotName", null, 0, 1, RFactSlot.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRFactSlot_SlotValueRange(), this.getRMultiField(), "slotValueRange", null, 0, 1, RFactSlot.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rPatternEClass, RPattern.class, "RPattern", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRPattern_FactTemplate(), this.getRFactTemplate(), null, "factTemplate", null, 0, 1, RPattern.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRPattern_SlotMatchExp(), this.getRSlotMatchExp(), null, "slotMatchExp", null, 0, -1, RPattern.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rSlotMatchExpEClass, RSlotMatchExp.class, "RSlotMatchExp", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRSlotMatchExp_FactTemplate(), this.getRFactTemplate(), null, "factTemplate", null, 0, 1, RSlotMatchExp.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRSlotMatchExp_SlotName(), this.getRSymbol(), "slotName", null, 0, 1, RSlotMatchExp.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRSlotMatchExp_MatchExp(), ecorePackage.getEString(), "matchExp", null, 0, 1, RSlotMatchExp.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rCondElemEClass, RCondElem.class, "RCondElem", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRCondElem_CeName(), this.getRCondElemEnum(), "ceName", null, 0, 1, RCondElem.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRCondElem_CeMatchPattern(), this.getRPattern(), null, "ceMatchPattern", null, 0, -1, RCondElem.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRCondElem_ChildCE(), this.getRCondElem(), null, "childCE", null, 0, -1, RCondElem.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rModuleEClass, RModule.class, "RModule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRModule_FactTemplates(), this.getRFactTemplate(), null, "factTemplates", null, 0, -1, RModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRModule_Rules(), this.getRRule(), null, "rules", null, 0, -1, RModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRModule_Rlists(), this.getRList(), null, "rlists", null, 0, -1, RModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRModule_Functions(), this.getRFunction(), null, "functions", null, 0, -1, RModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRModule_OutputFilePath(), ecorePackage.getEString(), "outputFilePath", null, 0, 1, RModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		addEOperation(rModuleEClass, null, "generate");

		initEClass(rObjectEClass, RObject.class, "RObject", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		addEOperation(rObjectEClass, ecorePackage.getEString(), "toListString");

		initEClass(rFunctionEClass, RFunction.class, "RFunction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRFunction_FunctionName(), this.getRSymbol(), "functionName", null, 0, 1, RFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRFunction_Parameters(), this.getRDataType(), "parameters", null, 0, -1, RFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRFunction_ReturnValue(), this.getRDataType(), "returnValue", null, 0, 1, RFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRFunction_FunctionType(), this.getRFunctionType(), "functionType", null, 0, 1, RFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rFactEClass, RFact.class, "RFact", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRFact_FactTemplate(), this.getRFactTemplate(), null, "factTemplate", null, 0, 1, RFact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRFact_Slots(), this.getRSymbolToDataTypeMapEntry(), null, "slots", null, 0, -1, RFact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rSymbolToDataTypeMapEntryEClass, Map.Entry.class, "RSymbolToDataTypeMapEntry", !IS_ABSTRACT, !IS_INTERFACE, !IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRSymbolToDataTypeMapEntry_Key(), this.getRSymbol(), "key", null, 0, 1, Map.Entry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRSymbolToDataTypeMapEntry_Value(), this.getRDataType(), "value", null, 0, 1, Map.Entry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(rCondElemEnumEEnum, RCondElemEnum.class, "RCondElemEnum");
		addEEnumLiteral(rCondElemEnumEEnum, RCondElemEnum.NOT_LITERAL);
		addEEnumLiteral(rCondElemEnumEEnum, RCondElemEnum.OR_LITERAL);
		addEEnumLiteral(rCondElemEnumEEnum, RCondElemEnum.AND_LITERAL);

		initEEnum(rRuleTypeEEnum, RRuleType.class, "RRuleType");
		addEEnumLiteral(rRuleTypeEEnum, RRuleType.CONSTRAINT_LITERAL);
		addEEnumLiteral(rRuleTypeEEnum, RRuleType.INITIALIZATION_LITERAL);

		initEEnum(rFunctionTypeEEnum, RFunctionType.class, "RFunctionType");
		addEEnumLiteral(rFunctionTypeEEnum, RFunctionType.SYSTEM_LITERAL);
		addEEnumLiteral(rFunctionTypeEEnum, RFunctionType.USERDEFINED_LITERAL);

		// Initialize data types
		initEDataType(rSymbolEDataType, RSymbol.class, "RSymbol", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(rFactAddressEDataType, RFactAddress.class, "RFactAddress", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(rIntegerEDataType, RInteger.class, "RInteger", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(rFloatEDataType, RFloat.class, "RFloat", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(rDataTypeEDataType, RDataType.class, "RDataType", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(rMultiFieldEDataType, RMultiField.class, "RMultiField", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);

		// Create resource
		createResource(eNS_URI);
	}

} //RulemetamodelPackageImpl
